unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

    type
    TMyObject=record
      cx,cy:integer; //  
      h,w:integer; //    
      n:integer; // - 
      m:array of Tpoint; //     
    end;

var
  Form1: TForm1;

  pr:TMyObject; //   
  dow:boolean=false;
  cx,cy:integer;
implementation
uses math;
{$R *.dfm}
 Function Dlina(a,b:Tpoint):real;
var x1,y1,x2,y2:real;
begin
x1:=a.x;
y1:=a.y;
x2:=b.x;
y2:=b.y;
   result:=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
end;




Function Ugol(a,b:Tpoint):real;
var Ch:integer;
begin
  result:=arctan2((a.y-b.y),(a.x-b.x));
end;











 Function CreateMyObject(cx,cy,h,w:integer;a1:integer):TMyObject;
 const n=6;
 var an,a:real;
     r:Extended;
     x:integer;
     h1,x1,y1:integer;
 begin
   a:=360/n;
   r:=SQRT(w*w+h*h);
   result.cx:=cx;
   result.cy:=cy;
   result.n:=n;
   if length(result.m)<n then
   setlength(result.m,n+1);
   an:=a1;
   r:=r/2;
   for x:=0 to n-1 do begin
     if x=0 then begin
       x1:=round(cx+r*cos((360-arctan(h/w)*180/pi+a1)*pi/180));
       y1:=round(cy+r*sin((360-arctan(h/w)*180/pi+a1)*pi/180));
       form1.Image1.Canvas.MoveTo(cx,cy);
       form1.Image1.Canvas.Lineto(x1,y1);
   end
   else
begin
   an:=an+a;
   if (x mod 2) <> 0 then h1:=h else h1:=w;
     x1:=round(x1+h1*cos(an*pi/180));
     y1:=round(y1+h1*sin(an*pi/180));
    end;
     result.m[x].X:=x1;
     result.m[x].y:=y1;
   end;
     result.m[n].X:=result.m[0].X;
     result.m[n].y:=result.m[0].y;
 end;






Procedure Povorot(var Val:TMyObject;cx,cy:integer;a:integer);
var i:integer;n:integer;
    d1:real; //    cx,cy   
    a1:real; //   
    x1,y1:integer; //   
begin
  n:=val.n;
     d1:=Dlina(point(val.cx,val.cy),point(cx,cy));
     a1:=Ugol(point(val.cx,val.cy),point(cx,cy));
//    
     val.cx:=cx+round(d1*cos(a1+a*pi/180));
     val.cy:=cy+round(d1*sin(a1+a*pi/180));
  for I:=0 to n-1 do begin
     d1:=Dlina(point(val.m[i].x,val.m[i].y),point(cx,cy));
     a1:=Ugol(point(val.m[i].x,val.m[i].y),point(cx,cy));
     x1:=cx+Round(d1*cos(a1+a*pi/180));
     y1:=cy+Round(d1*sin(a1+a*pi/180));
     val.m[i].X:=x1;
     val.m[i].y:=y1;
  end;
     val.m[n].X:=val.m[0].X;
     val.m[n].y:=val.m[0].y;
end;

Procedure DrawObject(Val:TMyObject;Canvas:Tcanvas);
begin
  canvas.Polygon(Val.m);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  pr:=CreateMyObject(form1.Image1.Width div 2,form1.Image1.Height div 2,80,80,5);
  DrawObject(pr,form1.Image1.Canvas);
  cx:=form1.Image1.Width div 2;
  cy:=form1.Image1.Height div 2;
  form1.Image1.Canvas.Ellipse(cx-8,cy-8,cx+8,cy+8);

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  form1.Image1.Canvas.Ellipse(cx-8,cy-8,cx+8,cy+8);
  form1.Image1.Canvas.Pen.Mode:=pmnotxor;
  DrawObject(pr,form1.Image1.Canvas);
  Povorot(pr,cx,cy,8);
  DrawObject(pr,form1.Image1.Canvas);

end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if ((cx-8)<x) and ((cx+8)>x) and ((cy-8)<y) and ((cy+8)>y) then dow:=true;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if dow then begin
    form1.Image1.Canvas.Pen.Mode:=pmnotxor;
    form1.Image1.Canvas.Ellipse(cx-8,cy-8,cx+8,cy+8);
    cx:=x;
    cy:=y;
    form1.Image1.Canvas.Ellipse(cx-8,cy-8,cx+8,cy+8);

   end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
dow:=false;
end;

end.
